
local addon  = KiwiPlates
local widget = addon:newWidget( 'Mouseover', { 'mouseover' } )
local Notify = addon.Notify
local SendColor = addon.SendColor
local PlateSendToBack   = addon.PlateSendToBack
local PlateBringToFront = addon.PlateBringToFront
local PlateSetHighlight = addon.PlateSetHighlightTexture

local db
local colorEnabled
local kHighlight

local function MouseEnter(kPlate, bPlate)
	if not bPlate.isTarget then
		PlateBringToFront(kPlate, bPlate, 'Mouseover', 127)
		if colorEnabled then
			SendColor.Mouseover( kPlate , db.glowColor )
		end
		local db = kPlate.db.Mouseover
		if db and not db.disableHighlight then
			PlateSetHighlight(kPlate, kHighlight, 'Mouseover' )
		end	
	end	
end

local function MouseLeave(kPlate)
	PlateSendToBack(kPlate, kPlate.bPlate, 'Mouseover' )
	kHighlight:Hide()
	if colorEnabled then
		SendColor.Mouseover( kPlate )
	end
end

function widget:OnSkinChange(skin)
	local tex = kHighlight and kHighlight[skin.name]
	if tex then
		addon.CreateHighlightTexture( kHighlight, skin.name, skin.Mouseover )
	end
end

function widget:OnEnable(addon, theme)
	db = theme.Mouseover
	if db then
		colorEnabled = db.colorReceivers and #db.colorReceivers>0
		kHighlight = kHighlight or CreateFrame( 'Frame' )
		addon.RegisterNotify( 'PlateMouseEnter', MouseEnter )
		addon.RegisterNotify( 'PlateMouseLeave', MouseLeave )
		addon.RegisterColorSender( 'Mouseover', db.colorReceivers, db.colorPriority or 5)
	end	
end

function widget:OnDisable(addon)
	addon.UnregisterNotify( 'PlateMouseEnter', Update )
	addon.UnregisterNotify( 'PlateMouseLeave', Update )
	addon.UnregisterColorSender( 'Mouseover' )	
end
