
local addon  = KiwiPlates
local widget = addon:newWidget( 'Reaction' )
local SendColor = addon.SendColor

local unpack = unpack
local CLASS_COLORS = addon.defaults.colors.Class

local color = {}
local Update

local function UpdateReaction(kPlate,bPlate)
	local db = addon.theme.Reaction
	if bPlate.vType == 'player' then
		if bPlate.vReaction ~= 'hostile' then
			if db.playerColorize == 'reaction' then
				SendColor.Reaction(kPlate, db.colors.playerfriendly)
				return
			elseif db.playerColorize == 'class' then
				local info = addon.GetPlateUnitInfo(bPlate)
				if info then
					SendColor.Reaction(kPlate, CLASS_COLORS[info.class])
				else	
					SendColor.Reaction(kPlate, db.colors.playerfriendly)
				end	
				return
			end
		end
	elseif db.npcColorize == 'reaction' then
		SendColor.Reaction( kPlate, db.colors[bPlate.vReaction] )
		return
	end
	color[1], color[2], color[3] = bPlate.bHealthBar:GetStatusBarColor()
	SendColor.Reaction(kPlate, color)
end

local function UpdateBlizzard(kPlate, bPlate)
	color[1], color[2], color[3] = bPlate.bHealthBar:GetStatusBarColor()
	SendColor.Reaction( kPlate, color )
end

function widget:GetStatuses(addon, theme)
	local db = theme.Reaction
	local statuses 
	if db.playerColorize ~= 'blizzard' or db.npcColorize ~= 'blizzard' then
		statuses = { 'reaction', 'classification' }
		if db.playerColorize == 'class' then
			table.insert( statuses, 'roster' )
		end	
	end	
	return statuses
end

function widget:OnEnable(addon, theme)
	local db = theme.Reaction
	Update = (db.playerColorize == 'blizzard' and db.npcColorize == 'blizzard') and UpdateBlizzard or UpdateReaction		
	addon.RegisterNotify( 'PlateShow', Update )
	addon.RegisterNotify( 'PlateReactionUpdate', Update )
	addon.RegisterColorSender( 'Reaction', db.colorReceivers, db.colorPriority or 1)
end

function widget:OnDisable(addon)
	addon.UnregisterNotify( 'PlateShow', Update )
	addon.UnregisterNotify( 'PlateReactionUpdate', Update )
	addon.UnregisterColorSender( 'Reaction' )
end

