local media = LibStub("LibSharedMedia-3.0", true)
local widget = KiwiPlates:newWidget( 'ClassificationText', { 'classification' } )

local function Show(kPlate,bPlate)
	local kText = kPlate.ClassificationText
	if kText then
		local type   = bPlate.vType
		if kPlate.db.ClassificationText.displayUnitLevel then
			if type == 'normal' then
				kText:SetFormattedText( 'Level %d', bPlate.vLevel )
				return
			elseif type ~= 'boss' then
				kText:SetFormattedText( '%s: %d', type, bPlate.vLevel )
				return
			end
		end
		kText:SetText( type )
	end	
end

local function Create(kPlate)
	local db = kPlate.db.ClassificationText
	if db then
		local Text = kPlate.ClassificationText or kPlate:CreateFontString(nil, "ARTWORK") 
		Text:SetFont( media:Fetch('font', db.fontName), db.fontSize, db.fontFlags)
		Text:SetTextColor( unpack(db.fontColor) )		
		Text:SetSize( db.width or kPlate.width, db.height or kPlate.height )
		Text:SetJustifyH( db.JustifyH )
		Text:SetJustifyV( db.JustifyV )
		Text:SetPoint( 'CENTER', db.left or 0, db.top or 0 )
		Text.SetColor = db.acceptColors and Text.SetTextColor or nil
		kPlate.ClassificationText = Text
	end	
end

function widget:OnEnable(addon)
	addon.RegisterNotify( 'PlateCreate', Create )
	addon.RegisterNotify( 'PlateShow', Show )
end

function widget:OnDisable(addon)
	addon.UnregisterNotify( 'PlateCreate', Create )
	addon.UnregisterNotify( 'PlateShow', Show )
end
