
local addon  = KiwiPlates
local module = addon:newWidget( 'TargetIcon' )
local bvPlates = addon.bvPlates
local PlateSendToBack   = addon.PlateSendToBack
local PlateBringToFront = addon.PlateBringToFront

local opaqueRI

local function Show(kPlate, bPlate)
	local db   = kPlate.db.TargetIcon
	local Icon = bPlate.bRaidTargetIcon
	if db then
		Icon:SetParent(kPlate)
		Icon:SetSize( db.width or 32, db.height or 32)
		Icon:SetDrawLayer('OVERLAY', 7)
		Icon:ClearAllPoints()
		Icon:SetPoint('CENTER', db.left or 0, db.top or 0)
	end
	if opaqueRI and Icon:IsVisible() then
		PlateBringToFront( kPlate, bPlate,  'TargetIcon' )
	end
end

local function Hide(kPlate)
	local Icon = kPlate.bPlate.bRaidTargetIcon
	Icon:SetParent(kPlate.bPlate)
end

local function UpdateAllPlates()
	for i=#bvPlates,1,-1 do
		local bPlate = bvPlates[i]
		if bPlate.bRaidTargetIcon:IsVisible() then
			PlateBringToFront( bPlate.kPlate, bPlate, 'TargetIcon' )
		else
			PlateSendToBack( bPlate.kPlate, bPlate, 'TargetIcon' )
		end
	end
end

local function ResetAllPlates()
	for i=#bvPlates,1,-1 do
		local bPlate = bvPlates[i]
		if bPlate.bRaidTargetIcon:IsVisible() then
			PlateSendToBack( bPlate.kPlate, bPlate, 'TargetIcon' )
		end
	end
end

function module:OnEnable(addon, db)
	opaqueRI = db and db.opaqueRaidIcons
	addon.RegisterNotify( 'PlateShow', Show)
	addon.RegisterNotify( 'PlateHide', Hide)
	if opaqueRI then 
		addon:RegisterEvent( 'RAID_TARGET_UPDATE', UpdateAllPlates ) 
		UpdateAllPlates()
	end	
end

function module:OnDisable(addon)
	addon.UnregisterNotify( 'PlateShow', Show )
	addon.UnregisterNotify( 'PlateHide', Hide )
	if opaqueRI then 
		addon:UnregisterEvent( 'RAID_TARGET_UPDATE') 
		ResetAllPlates()
	end	
end
